Require Export Reals.
Require Export Field_tac.
Require Import ZArith.
Open Scope R_scope.

Goal forall x,  x - x = 0.
intros; newfield.
Qed.
 
Goal forall x, x <> 0 ->  1 / (1 / (x * x)) = x * x.
intros; newfield.
auto with real.
Qed.
 
Goal forall x, x <> 0 ->  1 / (1 / x) = x.
intros; newfield.
auto with real.
Qed.

Goal forall x, x <> 0 ->  1 / x  + 1 /x  = 2/x.
intros; newfield.
auto with real.
Qed.

Goal forall x, x <> 0 ->  1 / (2*x)  + 1 /(2*x)  = 1/x.
intros; newfield.
auto with real.
Qed.

Goal forall x, x <> 0 ->  1 / (100*x)  + 1 /(100*x)  = 1/(50*x).
intros; newfield.
auto with real.
Qed.

Goal forall a b, a <> 0 -> b <> 0 -> a + b <> 0 -> 1 / (1 / a + 1 / b) = a * b / (a + b).
intros; newfield.
repeat (split; auto); rewrite Rplus_comm; auto.
Qed.
