
Require Export realbasis.
Require Export proof_utils.
Require Export real_facts.

Open Scope stream_scope.

Ltac apply_half_sum_correct hyp_id :=
 match goal with 
  id : represents ?x' ?u' , id1 : represents ?y' ?v' |- 
  represents (half_sum ?x' ?y') ?b =>
  replace b with ((u' + v')/2)%R;
    [apply hyp_id;assumption|field; auto with real1]
 end.

Ltac add_fact x :=
  match goal with id: represents (Cons ?d1 x) _, id1 : represents x ?v1
    |- context [Cons ?d2 x] =>
      let v := constr: (d2=d1) in
	match v with
      (?d = ?d) => interval_from_represents id; intros
    | (L = _) => assert(represents (Cons L x) (v1/2-1/2))
    | (R = _) => assert(represents (Cons R x) (v1/2+1/2))
    | (C = _) => assert(represents (Cons C x) (v1/2))
    end;[constructor; assumption | idtac]
  | id: represents (Cons ?d1 x) _ |- context [Cons ?d1 x] =>
      interval_from_represents id; intros
  | _ => idtac
  end.


Ltac prepare_represents_constructor :=
  match goal with
    |- represents (Cons R ?a) (?b/2) =>
       replace (b/2)%R with ((b - 1)/2+1/2)%R;[idtac | field ; auto with real1]
  | |- represents (Cons L ?a) (?b/2) => 
       replace (b/2)%R with ((b + 1)/2-1/2)%R;[idtac | field ; auto with real1]
  | |- represents (Cons C ?a) (?b/2) => idtac
  | |- _ => idtac
  end.

Theorem half_sum_correct :
  forall x y u v,
    represents x u -> represents y v -> represents (half_sum x y) ((u + v)/2).
cofix.
intros; rewrite (str_dec_thm (half_sum x y)); simpl.
destruct x as [ [ | | ] x']; destruct y as [[ | | ] y'];
prepare_represents_constructor;
try(
constructor;
[inversion H; inversion H0; apply_half_sum_correct half_sum_correct |
 clear half_sum_correct; intervals_from_represents H H0;
   split; auto with real1];fail);
destruct x' as [ [ | | ] x''];
prepare_represents_constructor; inversion H0;
inversion_to_variable x''; add_fact x'';
 try 
  (constructor;
    [apply_half_sum_correct half_sum_correct|
     clear half_sum_correct;dec_tac; autorewrite with real1;
       split; auto with real1]);
destruct y' as [ [ | | ] y''];
prepare_represents_constructor;
 inversion_to_variable y''; add_fact y''; inversion_to_variable x'';
add_fact x'';
try(constructor;
    [apply_half_sum_correct half_sum_correct|clear half_sum_correct; dec_tac;
     autorewrite with real1; split; auto with real1]).
Qed.

Theorem add_correct :
  forall x y u v, represents x u -> represents y v -> (-1<=u+v <= 1)%R ->
    represents (x + y)%S (u + v)%R.
intros x y u v H H0 H1; replace (u+v)%R with (2*((u+v)/2))%R.
unfold add.
apply mult2_correct.
rewrite half_plus_distr.
generalize (represents_interval _ _ H) (represents_interval _ _ H0); 
intros; dec_tac; split; fourier.
apply half_sum_correct; assumption.
field; auto with real1.
Qed.

