Require Import realbasis Field_tac.
(*
CoFixpoint subst_aux (x y:stream idigit) : stream idigit :=
  match x with 
    | L::x' => match y with
		 | L::y' => C::(subst_aux x' y')
		 | C::y' => match y' with
			      | L::y'' => C::(subst_aux x' (R::y''))
			      | C::y'' => match x' with
					    | L::x'' => L::(subst_aux (C::x'') (L::y''))
					    | C::x'' => C::(subst_aux (L::x'') (R::y''))
					    | R::x'' => C::(subst_aux (L::x'') y')
					  end
			      | R::y'' => L::(subst_aux x' (L::y''))
			    end
		 | R::y' => L::(subst_aux x' y')
	       end
    | C::x' => match y with
		 | L::y' => match x' with
			      | L::x'' => C::(subst_aux (R::x'') y')
			      | C::x'' => match y' with
					    | L::y'' => R::(subst_aux (L::x'') (C::y''))
					    | C::y'' => C::(subst_aux (R::x'') (L::y''))
					    | R::y'' => C::(subst_aux x' (L::y''))
					  end
			      | R::x'' => R::(subst_aux (L::x'') y')
			    end
		 | C::y' => C::(subst_aux x' y')
		 | R::y' => match x' with
			      | L::x'' => L::(subst_aux (R::x'') y')
			      | C::x'' => match y' with
					    | L::y'' => C::(subst_aux x' (R::y''))
					    | C::y'' => C::(subst_aux (L::x'') (R::y''))
					    | R::y'' => L::(subst_aux (R::x'') (C::y''))
					  end
			      | R::x'' => C::(subst_aux (L::x'') y')
			    end
	       end
    | R::x' => match y with
		 | L::y' => R::(subst_aux x' y')
		 | C::y' => match y' with
			      | L::y'' => R::(subst_aux x' (R::y''))
			      | C::y'' => match x' with
					    | L::x'' => C::(subst_aux (R::x'') y')
					    | C::x'' => C::(subst_aux (R::x'') (L::y''))
					    | R::x'' => R::(subst_aux (C::x'') (R::y''))
					  end
			      | R::y'' => C::(subst_aux x' (L::y''))
			    end
		 | R::y' => C::(subst_aux x' y')
	       end
  end.
*)
CoFixpoint subst_aux (x y:stream idigit) : stream idigit :=
  match (x, y) with 
      (L::x', L::y') => C::(subst_aux x' y')
    | (C::x', C::y') => C::(subst_aux x' y')
    | (R::x', R::y') => C::(subst_aux x' y')
    | (L::x', R::y') => L::(subst_aux x' y')
    | (R::x', L::y') => R::(subst_aux x' y')

    | (L::x', C::L::y') => C::(subst_aux x' (R::y'))
    | (L::x', C::R::y') => L::(subst_aux x' (L::y'))
    | (L::R::x', C::y') => C::(subst_aux (L::x') y')

    | (C::x', L::R::y') => C::(subst_aux x' (L::y'))
    | (C::x', R::L::y') => C::(subst_aux x' (R::y'))

    | (C::L::x', L::y') => C::(subst_aux (R::x') y')
    | (C::L::x', R::y') => L::(subst_aux (R::x') y')
    | (C::R::x', L::y') => R::(subst_aux (L::x') y')
    | (C::R::x', R::y') => C::(subst_aux (L::x') y')

    | (R::x', C::L::y') => R::(subst_aux x' (R::y'))
    | (R::x', C::R::y') => C::(subst_aux x' (L::y'))
    | (R::L::x', C::y') => C::(subst_aux (R::x') y')

    | (L::L::x', C::C::y') => L::(subst_aux (C::x') (L::y'))
    | (L::C::x', C::C::y') => C::(subst_aux (L::x') (R::y'))
 
    | (C::C::x', L::L::y') => R::(subst_aux (L::x') (C::y'))
    | (C::C::x', L::C::y') => C::(subst_aux (R::x') (L::y'))
    | (C::C::x', R::C::y') => C::(subst_aux (L::x') (R::y'))
    | (C::C::x', R::R::y') => L::(subst_aux (R::x') (C::y'))

    | (R::C::x', C::C::y') => C::(subst_aux (R::x') (L::y'))
    | (R::R::x', C::C::y') => R::(subst_aux (C::x') (R::y'))
end.


Definition str_dec (A:Set) (s : stream A) :=
  match s with a::l => a::l end.

Theorem str_dec_thm: forall (A:Set) (s:stream A), s = str_dec A s.
intros A s; case s.
simpl.
intros; reflexivity.
Qed.

Ltac str_unfold term :=
  rewrite (str_dec_thm _ term).

Lemma subs_aux_correct_aux1 :
  forall u v, ((u+1-v)/2 = (((2*u+1)+1-2*v)/2)/2)%R.
intros; newfield.
intros; field.
discrR.
Qed.

Lemma subs_aux_correct_aux2 :
  forall u v, ((u+1-v)/2 = (2*((2*u+1-2*v)/2)+1)/4)%R.
intros; field.
discrR.
Qed.

Lemma subs_aux_correct_aux3 :
  forall u v, ((u+1-v)/2 = ((2*u+1-(2*v+1))/2+1)/2)%R.
intros; field.
discrR.
Qed.

Ltac simpl_represent_ubs_aux :=
match goal with 
  id1 : represents ?x ?u, id2 : represents ?y ?v
  |- represents (?d::subst_aux ?x ?y) ?b => 
    replace b with 
      (match d with 
	| L => ((u+1-v)/2)/2 
	| C => (2*((u+1-v)/2)+1)/4
	| R => (((u+1-v)/2)+1)/2
       end) ; [idtac ; try apply subs_aux_correct_aux1; try apply subs_aux_correct_aux1; try apply subs_aux_correct_aux1]
(*      | L => replace (subs_aux_correct_aux1 u v) 
      | C => rewrite (subs_aux_correct_aux2 u v) 
      | R => rewrite (subs_aux_correct_aux3 u v) 
    end *)
end.

Ltac simpl_represent_ubs_aux2 :=
match goal with 
  |- represents (?d::subst_aux ?x ?y) ((?u+1-?v)/2) => 
      match d with 
      | L => replace (subs_aux_correct_aux1 u v) 
      | C => rewrite (subs_aux_correct_aux2 u v) 
      | R => rewrite (subs_aux_correct_aux3 u v) 
    end 
end.

(*Si le but est de prouver que ?b represente le resultat de subst_aux x y
que l'on sait que u et v representent x et y, on remplace b par (u+1-v)/2
et on applique l'hypothese de coinduction fournie 
*)
Ltac apply_half_subst_correct hyp_id :=
  match goal with 
    id : represents ?x' ?u' , id1 : represents ?y' ?v' |- 
      represents (subst_aux ?x' ?y') ?b =>
      replace b with ((u' + 1 - v')/2)%R;
	[apply hyp_id;assumption|auto(*newfield; auto with real1*)]
  end.

(*a quoi ca sert ? *)
Ltac add_fact x :=
  match goal with id: represents (Cons ?d1 x) _, id1 : represents x ?v1
    |- context [Cons ?d2 x] =>
      let v := constr: (d2=d1) in
	match v with
	  (?d = ?d) => (*interval_from_represents id;*) intros
	  | (L = _) => assert(represents (Cons L x) (v1/2))
	  | (R = _) => assert(represents (Cons R x) ((v1+1)/2))
	  | (C = _) => assert(represents (Cons C x) ((2*v1+1)/4))
	end;[constructor; assumption | idtac]
    | id: represents (Cons ?d1 x) _ |- context [Cons ?d1 x] =>
      (*interval_from_represents id;*) intros
    | _ => idtac
  end.


Theorem subs_aux_correct :
  forall x y u v, represents x u -> represents y v -> 
    represents (subst_aux x y) ((u + 1 - v)/2).
Proof.
cofix H.
intros x y u v.
str_unfold (subst_aux x y).
case x; case y.
intros y1 y' x1 x'.

case x1; case y1; inversion 1; inversion 1; simpl.
destruct x' as [[ | | ] x''].

try (simpl_represent_ubs_aux2).   constructor.

try apply H.
replace ((2 * (r / 2))%R) with r.
assumption.
field; discrR.
replace ((2 * (r0 / 2))%R) with r0.
assumption.
field; discrR.
replace ((2 * (r / 2))%R) with r.
replace ((2 * (r0 / 2))%R) with r0.




