Require Export realbasis.
Require Export proof_utils.
Require Export real_facts.

Open Scope stream_scope.

Theorem half_sum_correct_aux1 : 
  forall b k r1 r2,
    0 < b ->
    -2*b-1<= k <= -1 -> 
    ( -1 <= r1 <= 1 ->
      -1 <= r2 <= 1 ->
      -1 <= ((IZR (k + 2 * b) + r1) / IZR (2 * b) + r2) / 2 <= 1)%R.
Proof.
intros b k r1 r2 Hbpos U1 U2 U3.
assert (U4 : (IZR k<= -1)%R).
apply (IZR_le k (-1)); omega.
assert (U5: (IZR (-4*b) +1 <= IZR k)%R).
change 1%R with (IZR 1).
rewrite <- plus_IZR.
apply IZR_le; omega.
assert (U6 : (-1<=((IZR (k + 2 * b) + r1) / IZR (2 * b))<=1)%R).
unfold Rdiv.
split; (apply Rmult_le_reg_l with (IZR (2*b)); [apply (IZR_lt 0); omega| idtac]);
rewrite <- Rmult_assoc; (rewrite Rinv_r_simpl_m; [idtac| discrR; omega]);
(replace (IZR (k+ 2 * b) + r1)%R with 
  (IZR (2 * b)+ (IZR k+r1))%R; [idtac|rewrite plus_IZR; ring]).
replace (IZR (2 * b) * -1)%R with ((IZR (2*b))+ IZR (-4*b) )%R.
apply Rplus_le_compat_l.
dec_tac; fourier.
replace (-4) with (-2*2)%Z; ring.
repeat rewrite mult_IZR.
change (IZR 2) with 2%R.
change (IZR (-2)) with (-2)%R.
ring.
replace (IZR (2 * b) * 1)%R with ((IZR (2*b))+ 0 )%R;[idtac|ring].
apply Rplus_le_compat_l.
dec_tac; fourier.
generalize U6; clear U6.
generalize ((IZR (k + 2 * b) + r1) / IZR (2 * b))%R.
intros r U6.
replace ((r + r2) / 2)%R with (r/2+r2/2)%R; [idtac|newfield].
dec_tac; split; fourier.
Qed.

Theorem half_sum_correct_aux2 : 
  forall b k r1 r2,
    0 < b ->
    1<= k <= 2*b-1 -> 
    ( -1 <= r1 <= 1 ->
      -1 <= r2 <= 1 ->
      -1 <= ((IZR (k - 2 * b) + r1) / IZR (2 * b) + r2) / 2 <= 1)%R.
Proof.
intros b k r1 r2 Hbpos U1 U2 U3.
assert (U4 : (1<=IZR k)%R).
apply (IZR_le 1); omega.
assert (U5: (IZR k <= IZR (4*b) -1)%R).
change 1%R with (IZR 1).
rewrite Z_R_minus.
apply IZR_le; omega.
assert (U6 : (-1<=((IZR (k - 2 * b) + r1) / IZR (2 * b))<=1)%R).
unfold Rdiv.
split; (apply Rmult_le_reg_l with (IZR (2*b)); [apply (IZR_lt 0); omega| idtac]);
rewrite <- Rmult_assoc; (rewrite Rinv_r_simpl_m; [idtac| discrR; omega]); 
(replace (IZR (k- 2 * b) + r1)%R with (-IZR (2 * b)+ (IZR k+r1))%R; 
  [idtac|rewrite <- Z_R_minus; ring]).
replace (IZR (2 * b) * -1)%R with (-(IZR (2*b))+ 0)%R; [idtac|ring].
apply Rplus_le_compat_l.
dec_tac; fourier.
replace (IZR (2 * b) * 1)%R with (-(IZR (2*b))+ (IZR (4*b)) )%R;[idtac|ring].
apply Rplus_le_compat_l.
dec_tac; fourier.
replace 4 with (2*2)%Z; [idtac|ring].
repeat rewrite mult_IZR.
change (IZR 2) with 2%R.
ring.
generalize U6; clear U6.
generalize ((IZR (k - 2 * b) + r1) / IZR (2 * b))%R.
intros r U6.
replace ((r + r2) / 2)%R with (r/2+r2/2)%R; [idtac|newfield].
dec_tac; split; fourier.
Qed.

Theorem half_sum_correct_aux3 : 
  forall b k r1 r2,
    0 < b ->
    0<= k <= 2*b-1 -> 
    ( -1 <= r1 <= 1 ->
      -1 <= r2 <= 1 ->
      -1 <= ((IZR (0 - b) + r1) / IZR (2 * b) +
	(IZR (k - b) + r2) / IZR (2 * b)) /2 <= 1)%R.
Proof.
intros b k r1 r2 Hbpos U1 U2 U3.
match goal with |- (-1<= (?x1 + ?x2)/2 <= 1)%R =>
  cut (-1<= x1 <= 1)%R;[ cut (-1<= x2 <= 1)%R; [
    replace ((x1 + x2)/2)%R with (x1/2+x2/2)%R; [
      generalize x1; generalize x2; intros; dec_tac; split; fourier
      |newfield; discrR;omega] | idtac] | idtac]
end;
unfold Rdiv;
split; (apply Rmult_le_reg_l with (IZR (2*b)); [apply (IZR_lt 0); omega| idtac]);
rewrite <- Rmult_assoc; (rewrite Rinv_r_simpl_m; [idtac| discrR; omega]); 
(replace (IZR (k- 2 * b) + r1)%R with (-IZR (2 * b)+ (IZR k+r1))%R; 
  [idtac|rewrite <- Z_R_minus; ring]).
replace (IZR (2 * b) * -1)%R with ( IZR (k - b) + (IZR (-b -k)))%R. 
apply Rplus_le_compat_l.
apply Rle_trans with (-1)%R; intuition.
apply (IZR_le (-b-k) (-1)); omega.
repeat rewrite <- Z_R_minus; rewrite Ropp_Ropp_IZR; rewrite mult_IZR.
change (IZR 2) with 2%R;newfield.
replace (IZR (2 * b) * 1)%R with ( IZR (k - b) + (IZR ((1+2)*b -k)))%R. 
apply Rplus_le_compat_l.
apply Rle_trans with 1%R; intuition.
apply (IZR_le 1); omega.
repeat rewrite <- Z_R_minus; repeat rewrite mult_IZR.
rewrite plus_IZR.
change (IZR 2) with 2%R; change (IZR 1) with 1%R; newfield.
replace (IZR (2 * b) * -1)%R with ( IZR (0 - b) + (IZR (-b)))%R. 
apply Rplus_le_compat_l.
apply Rle_trans with (-1)%R; intuition.
apply (IZR_le (-b) (-1)); omega.
repeat rewrite <- Z_R_minus; rewrite Ropp_Ropp_IZR; rewrite mult_IZR.
change (IZR 2) with 2%R;change (IZR 0) with 0%R; newfield.
replace (IZR (2 * b) * 1)%R with ( IZR (0 - b) + (IZR ((1+2)*b)))%R. 
apply Rplus_le_compat_l.
apply Rle_trans with 1%R; intuition.
apply (IZR_le 1); omega.
rewrite <- Z_R_minus; repeat rewrite mult_IZR; change (IZR 0) with 0%R.
rewrite plus_IZR.
change (IZR 2) with 2%R; change (IZR 1) with 1%R; newfield.
Qed.

Theorem half_sum_correct :
  forall b x y u v,
    0 < b ->
    represents b x u -> 
    represents b y v -> 
    represents b (half_sum b x y) ((u + v)/2).
Proof.
cofix.
intros b x y u v Hbpos Hrepx Hrepy.
str_unfold (half_sum b x y).
destruct x as [ [k1] x']; destruct y as [[l1] y'].
Opaque Zmult.
simpl.
Transparent Zmult.
assert (Haux : 2>0); [omega|idtac].
generalize (Z_mod_lt (k1 + l1) 2 Haux).
intros [Hmodge Hmodlt].
elim (Z_le_gt_dec ((k1 + l1) mod 2)). 
intros Hmod.
assert (Hmodeq: (k1 + l1) mod 2 =0).
apply Zle_antisym; omega.
clear Hmod Hmodge Hmodlt.
set (j := (k1 + l1) / 2).
assert (H2j: (2*j = k1+l1)%Z).
unfold j.
pattern (k1 + l1)%Z at 2.
rewrite (Z_div_mod_eq (k1+l1) 2).
rewrite Hmodeq; ring.
omega.
inversion Hrepx.
inversion Hrepy.
replace  (((IZR k1 + r) / IZR (2 * b) + (IZR l1 + r0) / IZR (2 * b)) / 2)%R with 
  ((IZR j + (r + r0)/2 )/ IZR (2*b))%R.
constructor.
apply half_sum_correct; assumption. 
clear half_sum_correct.
replace ((r + r0) / 2)%R with (r/2+r0/2)%R;[ idtac| newfield].
dec_tac; split; fourier.
omega.
replace (IZR j) with (IZR k1 / 2 + IZR l1/ 2)%R. 
newfield; discrR; omega.
apply Rmult_eq_reg_l with 2%R; [idtac|discrR].
rewrite <- (mult_IZR 2).
rewrite H2j.
rewrite plus_IZR.
newfield.
intros Hmod.
assert (Hmodeq: (k1 + l1) mod 2 =1).
apply Zle_antisym; omega.
clear Hmod Hmodge Hmodlt.
set (j := (k1 + l1) / 2).
assert (H2j: (2*j + 1 = k1 + l1)%Z).
unfold j.
pattern (k1+l1)%Z at 2.
rewrite (Z_div_mod_eq (k1+l1) 2).
rewrite Hmodeq; ring.
omega.
assert (Hj: j= (k1+l1-1)/2).
rewrite <- H2j.
replace (2*j+1-1)%Z with (j*2)%Z; [idtac|ring].
symmetry; apply Z_div_mult; omega.
assert (Hjp1:  (j+1= (k1+l1+1)/2)%Z).
rewrite <- H2j.
replace (2*j+1+1)%Z with ((j+1)*2)%Z; [idtac|ring].
symmetry; apply Z_div_mult; omega.

destruct x' as [ [k2] x''].
elim (Z_le_gt_dec k2 (-1)).

(*k2 <= -1*)
intros Hk2le0.
inversion_to_variable x''.
inversion Hrepy.
replace (((IZR k1 + (IZR k2 + r0) / IZR (2 * b)) / IZR (2 * b) +
       (IZR l1 + r1) / IZR (2 * b)) / 2)%R with 
((IZR ((k1+l1-1)/2) + ( (IZR (k2+2*b) + r0  )/ IZR (2*b)  + r1 )/2) / IZR (2*b))%R. 
constructor.
apply half_sum_correct; try assumption.
constructor; try assumption; omega.
apply half_sum_correct_aux1; try assumption; omega.
rewrite <- Hj; omega.

replace (IZR ((k1 + l1 - 1) / 2)) with ((IZR k1 + IZR l1 -1)/2)%R. 
rewrite plus_IZR; rewrite mult_IZR; change (IZR 2) with 2%R.
newfield; discrR; omega.
rewrite <- plus_IZR.
rewrite <- Hj.
rewrite <- H2j.
rewrite Zmult_comm.
rewrite plus_IZR; rewrite mult_IZR; 
change (IZR 2) with 2%R; change (IZR 1) with 1%R.
newfield.

(*k2 >= 1*)
elim (Z_le_gt_dec 1 k2).
intros Hk2le1 _.
inversion_to_variable x''.
inversion Hrepy.
replace (((IZR k1 + (IZR k2 + r0) / IZR (2 * b)) / IZR (2 * b) +
       (IZR l1 + r1) / IZR (2 * b)) / 2)%R with 
((IZR ((k1+l1+1)/2) + ( (IZR (k2-2*b) + r0  )/ IZR (2*b)  + r1 )/2) / IZR (2*b))%R. 
constructor.
apply half_sum_correct; try assumption.
constructor; try assumption; omega.
apply half_sum_correct_aux2; try assumption; omega.
rewrite <- Hjp1; omega.

replace (IZR ((k1 + l1 + 1) / 2)) with ((IZR k1 + IZR l1 +1)/2)%R. 
rewrite <- Z_R_minus; rewrite mult_IZR; change (IZR 2) with 2%R.
newfield; discrR; omega.
rewrite <- plus_IZR.
rewrite <- Hjp1.
rewrite <- H2j.
rewrite Zmult_comm.
repeat rewrite plus_IZR; rewrite mult_IZR; 
change (IZR 2) with 2%R; change (IZR 1) with 1%R.
newfield.

destruct y' as [ [l2] y''].
elim (Z_le_gt_dec l2 (-1)).

(*l2 <= -1*)
intros Hl2le0 _ _ .
inversion_to_variable y''.
inversion Hrepx.
replace (((IZR k1 + r1) / IZR (2 * b) +
       (IZR l1 + (IZR l2 + r0) / IZR (2 * b)) / IZR (2 * b)) / 2)%R with 
((IZR ((k1+l1-1)/2) + ( r1 + (IZR (l2+2*b) + r0  )/ IZR (2*b) )/2) / IZR (2*b))%R. 
constructor.
apply half_sum_correct; try assumption.
constructor; try assumption; omega.
rewrite Rplus_comm.
apply half_sum_correct_aux1; try assumption; omega.
rewrite <- Hj; omega.

replace (IZR ((k1 + l1 - 1) / 2)) with ((IZR k1 + IZR l1 -1)/2)%R. 
rewrite plus_IZR; rewrite mult_IZR; change (IZR 2) with 2%R.
newfield; discrR; omega.
rewrite <- plus_IZR.
rewrite <- Hj.
rewrite <- H2j.
rewrite Zmult_comm.
rewrite plus_IZR; rewrite mult_IZR; 
change (IZR 2) with 2%R; change (IZR 1) with 1%R.
newfield.

(*l2 >= 0*)
intros Hk2le0 U1 U2.
assert (k2 = 0).
apply Zle_antisym; omega.
clear U1 U2; subst k2.
inversion_to_variable y''.
inversion_to_variable x''.
replace (((IZR k1 + (IZR 0 + r2) / IZR (2 * b)) / IZR (2 * b) +
       (IZR l1 + (IZR l2 + r0) / IZR (2 * b)) / IZR (2 * b)) / 2)%R with 
((IZR ((k1+l1+1)/2) + ( (IZR (0-b) + r2  )/ IZR (2*b) + (IZR (l2-b) + r0  )/ IZR (2*b) )/2) / IZR (2*b))%R. 
constructor.
apply half_sum_correct; try assumption.
constructor; try assumption; omega.
constructor; try assumption; omega.
apply half_sum_correct_aux3; try assumption; omega.
rewrite <- Hjp1; omega.

replace (IZR ((k1 + l1 + 1) / 2)) with ((IZR k1 + IZR l1 +1)/2)%R. 
repeat rewrite <- Z_R_minus; rewrite mult_IZR; change (IZR 2) with 2%R.
change (IZR 0) with 0%R.
newfield; discrR; omega.
rewrite <- plus_IZR.
rewrite <- Hjp1.
rewrite <- H2j.
rewrite Zmult_comm.
repeat rewrite plus_IZR; rewrite mult_IZR; 
change (IZR 2) with 2%R; change (IZR 1) with 1%R.
newfield.
Qed.

Theorem add_correct :
  forall b x y u v, 
    0 < b ->
    represents b x u -> 
    represents b y v -> 
    (-1<=u+v <= 1)%R ->
    represents b (add b x y) (u + v)%R.
Proof.
intros b x y u v Hbpos Hrepx Hrepy Hupv.
replace (u+v)%R with (2*((u+v)/2))%R; [idtac|newfield].
unfold add.
apply mult2_correct.
assumption.
replace ((u + v) / 2)%R with (u/2 + v/2)%R; [idtac|newfield]. 
dec_tac; split; fourier.
apply half_sum_correct; assumption.
Qed.
